---------------------------------
-- Шон (соло-гитара, гик-геймер)
---------------------------------

room_sean = room {
  nam = 'Гримёрка соло-гитариста',
  pic = pic 'img/sean.jpg',
  enter = function()
    if sean._aim == 2 then
      set_music 'mus/pacman.ogg'
    else
      set_music 'mus/stilbite.ogg'
    end
  end,
  way = { vroom('Выйти', 'dressrooms') },
  obj = {
    'cd',
    'guitar_sean',
    'notebook',
    'sean',
  },
}

cd = obj {
  nam = 'диски',
  dsc = [[ Свободного места в комнате почти нет, так как всё завалено {CD-дисками}. ]],
  act = [[ В основном это игры, начиная ещё с первых квестов Lucas Art. Я не буду копаться в его дисках. ]],
}

guitar_sean = obj {
  nam = 'гитара',
  dsc = [[ В углу сиротливо стоит {гитара}. ]],
  act = [[ Музыканты такой нервный народ -- лучше не трогать их инструменты. ]],
}

notebook = obj {
  nam = 'ноутбук',
  dsc = function()
    if sean._aim ~= 2 then
      p [[ На журнальном столике лежит закрытый {ноутбук}. ]]
    end
  end,
  act = [[ Очень непривычно видеть ноутбук Шона закрытым. ]],
  used = function(s, w)
    if w == charge then
      if charge._fixed then
        p [[ Я поставил ноутбук на зарядку. Воспрявший духом гитарист немедленно погрузился в игру. ]]
        inv():del('charge')
        sean._aim = 2
        set_music 'mus/pacman.ogg'
      else
        p [[ Зачем? Зарядка без кабеля бесполезна. ]]
      end
    end
  end,
}

sean = obj {
  nam = 'Шон',
  _is_musician = true,
  dsc = function(s)
    if s._aim == 2 then
      p [[ Я вижу спину {Шона}, который склонился над ноутбуком и проходит очередной уровень игры. ]]
    else
      p [[ Рядом прямо на полу сидит {Шон} и печально взирает на столик. ]]
    end
  end,
  act = function()
    walk 'dlg_sean'
  end,
  used = function(s, w)
    if w == charge then
      if w._fixed then
        p [[ Я отдал зарядку Шону. Воспрявший духом гитарист немедленно подключил ноутбук к питанию и погрузился в игру. ]]
        inv():del('charge')
        sean._aim = 2
        set_music 'mus/pacman.ogg'
      else
        p [[ -- Ну и на что мне зарядка, если её нечем подключить к розетке? ]]
      end
    end
  end,
}

dlg_sean = dlg {
  nam = 'Соло-гитарист Шон',
  pic = pic 'img/sean.jpg',
  hideinv = true,
  enter = function()
    if sean._aim == 2 then
      p [[ Через минуту Шон поставил игру на паузу и неохотно оторвался от своего ноутбука:^ -- Ну чего тебе?  ]]
    end
  end,
  talk = {
    {
      [[ Что сидишь не весел, буйну голову повесил? ]],
      cond = code [[ return not sean._aim ]],
      act = [[ -- Представляешь, я почти прошёл его! ]],
      stage = 'explain',
      {
        [[ Кого "его"? ]],
        act = [[ -- Да последний уровень в этой новой игре. А тут у ноута сел аккумулятор. Что за невезуха! ]],
        stage = 'lastlevel',
        {
          [[ Ну и ладно, потом, дома доиграешь! Сейчас всё равно пора на сцену. ]],
          act = function()
            p [[ -- Нет, я не смогу играть на сцене пока не доиграю на ноутбуке. ]]
            sean._aim = 1
          end,
          {
            [[ Если я найду тебе зарядку, ты выйдешь на сцену? ]],
            act = [[ Само собой! Я выступлю, только найди мне зарядное устройство. ]],
          }
        },
        {
          [[ А чего не поставишь его на зарядку от сети? ]],
          act = [[ -- Забыл зарядное устройство дома. ]],
          stage = 'lastlevel',
        },
      },
    },
    {
      [[ Вы все будто сговорились! Интересно, почему ты ещё не на сцене? ]],
      cond = code [[ return not sean._aim ]],
      act = [[ -- Представляешь, я почти прошёл его! ]],
      stage = 'explain',
    },
    {
      [[ Ну и что? ]],
      cond = code [[ return sean._aim == 1 ]],
      persist = true,
      act = [[ -- Найди мне зарядное устройство для ноутбука! Я быстренько пройду уровень и смогу выступать... ]],
    },
    {
      [[ Смотри, я нашел зарядку! Правда, она без кабеля питания... ]],
      cond = code [[ return have('charge') and not charge._fixed ]],
      persist = true,
      act = [[ -- Эх, найти бы ещё к ней кабель питания -- гитарист неcколько оживился. ]],
    },
    {
      [[ Смотри, я нашел тебе зарядку! ]],
      cond = code [[ return have('charge') and charge._fixed ]],
      persist = true,
      act = function()
        p [[ -- Спасибо, выручил!^
          Гитарист немедленно подключил ноутбук к питанию и погрузился в игру. ]]
        inv():del('charge')
        sean._aim = 2
        set_music 'mus/pacman.ogg'
      end,
    },
    {
      [[ Ваш ударник, похоже, вчера перепил... Не знаешь, чем можно быстро снять похмелье? ]],
      cond = code [[ return chuck._aim == 1 and not have('recipe') ]],
      persist = true,
      act = [[ -- Ну купи ему пива. ]],
      {
        [[ Ещё его пьяным на сцене мне не хватало! Нет уж, нужно что-то без алкоголя. ]],
        act = function()
          if sean._aim == 2 then
            p [[ -- Сейчас гляну в интернете... Вот записывай!^
            Через минуту у меня был отличный рецепт антипохмельного коктейля.^^ ]]
            take('recipe')
            recipe:inv()
          else
            p [[ -- Я бы нашел тебе в интернете, но у меня не работает ноутбук. ]]
          end
        end,
      },
    },
    {
      [[ У тебя чисто случайно нет томатного сока? ]],
      cond = code [[ return cup:need('tomato') ]],
      act = [[ -- Нет ]],
      stage = 'top',
    },
    {
      [[ У тебя чисто случайно нет сырого яйца? ]],
      cond = code [[ return cup:need('egg') ]],
      act = [[ -- Нет ]],
      stage = 'top',
    },
    {
      [[ У тебя чисто случайно нет аспирина? ]],
      cond = code [[ return cup:need('aspirin') ]],
      act = [[ -- Нет ]],
      stage = 'top',
    },
    {
      [[ У тебя чисто случайно нет соли? ]],
      cond = code [[ return cup:need('') ]],
      act = [[ -- Нет. ]],
      stage = 'top',
    },
    {
      [[ У тебя чисто случайно нет красного перца? ]],
      cond = code [[ return cup:need('') ]],
      act = [[ -- Нет. ]],
      stage = 'top',
    },
    {
      [[ Ничего, ничего. Не буду тебе мешать. ]],
      cond = code [[ return sean._aim == 2]],
      persist = true,
    },
  },
}

